package be.jeffcheasey88.peeratcode.parser.java.operations;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import be.jeffcheasey88.peeratcode.parser.java.ArrayBuffer;
import be.jeffcheasey88.peeratcode.parser.java.CleanerPool;
import be.jeffcheasey88.peeratcode.parser.java.JavaElement;

public class ElseOperation extends OperationContainer{
	
	private static Pattern PATTERN = Pattern.compile("^(\\s*else\\s*)");
	private static Pattern PATTERN_CLEANER = Pattern.compile("^(\\^GENERIC_FUNCTION\\d+)");
	
	public ElseOperation(){}

	@Override
	public int parse(String content, CleanerPool global, CleanerPool local) throws Exception{
		Matcher matcher = PATTERN.matcher(content);
		matcher.lookingAt();
		
		int index = matcher.group(1).length();
		content = content.substring(index);

		int bodysize;
		if(content.startsWith("^")){
			matcher = PATTERN_CLEANER.matcher(content);
			matcher.lookingAt();
			
			content = matcher.group(1);
			
			bodysize = content.length();
			content = local.unzipOne(content, (s,p) -> s);
			content = content.substring(1, content.length()-1);
			content = local.clean(content);
			super.parse(content, global, local);
		}else{
			bodysize = parseOne(content, global, local);
		}
		
		return index+bodysize;
	}
	
	@Override
	public void build(ArrayBuffer<String> buffer, int tab) throws Exception{
		super.build(buffer, tab);
		buffer.append((s) -> s+="else ");
		
		boolean oneOperation = getChilds().size() == 1;
		if(oneOperation){
			getChilds().get(0).build(buffer, 0);
			return;
		}
		
		buffer.append((s) -> s+="{");
		buffer.add("");
		for(JavaElement child : getChilds()) child.build(buffer, tab+1);
		
		super.build(buffer, tab);
		buffer.append((s) -> s+="}");
		buffer.add("");
	}
	
}

